commit a5e94b47b3abb7afb0ceae8389beca2bf9d770bb
Author: jklowden <jklowden>
Date:   Wed Jan 7 02:58:47 2009 +0000

    print numeric sized correctly

diff --git a/src/apps/defncopy.c b/src/apps/defncopy.c
index c1addcb..0f462ec 100644
--- a/src/apps/defncopy.c
+++ b/src/apps/defncopy.c
@@ -48,7 +48,7 @@
 #include <sybdb.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: defncopy.c,v 1.12 2005/10/12 07:03:21 freddy77 Exp $";
+static char software_version[] = "$Id: defncopy.c,v 1.13 2009/01/07 02:58:47 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
@@ -223,6 +223,17 @@ parse_argument(const char argument[], PROCEDURE* procedure)
 	}
 }
 
+char * rtrim(char * s);
+
+char *
+rtrim(char * s)
+{
+	char *p = strchr(s, ' ');
+	if (p) 
+		*p = '\0';
+	return s;
+}
+
 /*
  * Get the table information from sp_help, because it's easier to get the index information (eventually).  
  * The column descriptions are in resultset #2, which is where we start.  
@@ -409,8 +420,11 @@ print_ddl(DBPROCESS *dbproc, PROCEDURE *procedure)
 
 		/* get size of decimal, numeric, char, and image types */
 		if (0 == strcasecmp("decimal", ddl[i].type) || 0 == strcasecmp("numeric", ddl[i].type)) {
-			if (ddl[i].precision && 0 != strcasecmp("NULL", ddl[i].precision))
-				ret = asprintf(&type, "%s(%d,%d)", ddl[i].type, *(int*)ddl[i].precision, *(int*)ddl[i].scale);
+			if (ddl[i].precision && 0 != strcasecmp("NULL", ddl[i].precision)) {
+				rtrim(ddl[i].precision);
+				rtrim(ddl[i].scale);
+				ret = asprintf(&type, "%s(%s,%s)", ddl[i].type, ddl[i].precision, ddl[i].scale);
+			}
 		} else {
 			for (t = varytypenames; *t; t++) {
 				if (0 == strcasecmp(*t, ddl[i].type)) {

